=begin
#-----------------------------------------------------------------------------
Position_shadows_v1.2
(c) honoluludesktop 2010

Freely use, and abuse at your own risk. Fitness of use is 
not warranty implied.

Unzip files. If you already have an "hdt_folder" in the Sketchup 
"plugins folder", copy the files from the unzipped hdt_folder into 
Sketchup's "plugins\hdt_folder". Do not replace the original Sketchup 
"hdt_folder". Also copy "move_shadows.rb" into Sketchup's "plugins 
folder".

From the Sketchup menu, select View > Toolbar, and check 
"Position Shadows" to turn on the plugin's toolbar icons.

The sun shadows resulting from this application, are not accurate
located on the model in terms of real sun angles. Use for presentation 
purposes only. The menu's arrow icons creates the appearance of
moving the shadows in gross increments. Sketchup's date, time shadow 
control data has no meaning. Use these controls to fine tune the shadow 
location. Go to Window > Model Info, select Geo-location, and select 
your model's location to return the shadow's behavior to their normal 
condition.

11/28/2010 - v 0.1 Beta release
11/30/2010 - v 1.0 Remove increments when sun out of view.
#-----------------------------------------------------------------------------
=end

def hdt_sun_get_cnt_lat_long
#  result = Sketchup.send_action "showRubyPanel:"

	@inc=30													#increment change in latitude or longitude
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
#	shadowinfo["City"]="Honolulu, Hi"		#set current location
#	@save_latitude=shadowinfo["Latitude"]
#	@save_longitude=shadowinfo["Longitude"]
	latitude=shadowinfo["Latitude"]
	longitude=shadowinfo["Longitude"]
	return latitude, longitude
end

def hdt_display_lat_long
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
	test_next=shadowinfo["SunDirection"]
	test=true
	if test_next[2]<=0
		test=false
	end
	Sketchup.set_status_text "Sun Direction: [ #{test_next}]", SB_PROMPT
	return test
end

def hdt_sun_add_lat(latitude)					#arrow up
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
	shadowinfo["DisplayShadows"]=true
	test=false
	while test==false
		if latitude+@inc>=90
				latitude=latitude-180+@inc
		else
			latitude=latitude+@inc
		end
		shadowinfo["Latitude"]=latitude
		test=hdt_display_lat_long
	end
	return latitude
end

def hdt_sun_sub_lat(latitude)					#arrow dn
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
	shadowinfo["DisplayShadows"]=true
	test=false
	while test==false
		if latitude-@inc<=-90
			latitude=latitude+180-@inc
		else
			latitude=latitude-@inc
		end
		shadowinfo["Latitude"]=latitude
		test=hdt_display_lat_long
	end
	return latitude
end

def hdt_sun_add_long(longitude)				#arrow right
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
	shadowinfo["DisplayShadows"]=true
	test=false
	while test==false
		if longitude+(2*@inc)>=180
			longitude=longitude-360+(2*@inc)
		else
			longitude=longitude+(2*@inc)
		end
		shadowinfo["Longitude"]=longitude
		test=hdt_display_lat_long
	end
	return longitude
end

def hdt_sun_sub_long(longitude)				#arrow left
	model = Sketchup.active_model
	shadowinfo=model.shadow_info
	shadowinfo["DisplayShadows"]=true
	test=false
	while test==false
		if longitude-(2*@inc)<= -180
			longitude=longitude+360-(2*@inc)
		else
			longitude=longitude-(2*@inc)
		end
		shadowinfo["Longitude"]=longitude
		test=hdt_display_lat_long
	end
	return longitude
end

unless file_loaded? File::basename(__FILE__)
	file_path_name = Sketchup.find_support_file("plugins")
	#file_path_name=Sketchup.find_support_file "sketchup.exe", "" 
	file_path_name=File.dirname(file_path_name)+"/Plugins/hdt_folder/"

	latitude, longitude=hdt_sun_get_cnt_lat_long
	
	select_tb = UI::Toolbar.new("Position Shadows") 
	cmd4 = UI::Command.new("Decrement West") { longitude=hdt_sun_sub_long(longitude) } 
	cmd4.small_icon = file_path_name+"arrows_left_16.png" 
	cmd4.large_icon = file_path_name+"arrows_left_24.png"
	cmd4.tooltip = "Decrement Shadows West" 
	select_tb.add_item(cmd4) 
	
	cmd2 = UI::Command.new("Increment North") { latitude=hdt_sun_add_lat(latitude) } 
	cmd2.small_icon = file_path_name+"arrows_up_16.png" 
	cmd2.large_icon = file_path_name+"arrows_up_24.png"
	cmd2.tooltip = "Increment Shadows North" 
	select_tb.add_item(cmd2) 

	cmd3 = UI::Command.new("Decrement South") { latitude=hdt_sun_sub_lat(latitude) } 
	cmd3.small_icon = file_path_name+"arrows_down_16.png" 
	cmd3.large_icon = file_path_name+"arrows_down_24.png"
	cmd3.tooltip = "Decrement Shadows South" 
	select_tb.add_item(cmd3) 

	cmd1 = UI::Command.new("Increment East") { longitude=hdt_sun_add_long(longitude) } 
	cmd1.small_icon = file_path_name+"arrows_right_16.png" 
	cmd1.large_icon = file_path_name+"arrows_right_24.png"
	cmd1.tooltip = "Increment Shadows East" 
	select_tb.add_item(cmd1) 

  	add_separator_to_menu("Tools")
	menu=UI.menu("Tools").add_submenu('Move Shadows')
	menu.add_item("Increment North") { latitude=hdt_sun_add_lat(latitude) }
	menu.add_item("Decrement South") { latitude=hdt_sun_sub_lat(latitude) }
	menu.add_item("Increment East") { longitude=hdt_sun_add_long(longitude) }
	menu.add_item("Decrement West") { longitude=hdt_sun_sub_long(longitude) }
	#UI.menu("Tools").add_item("Increment Shadows North") { latitude=hdt_sun_add_lat(latitude) }
	#UI.menu("Tools").add_item("Decrement Shadows South") { latitude=hdt_sun_sub_lat(latitude) }
	#UI.menu("Tools").add_item("Increment Shadows East") { longitude=hdt_sun_add_long(longitude) }
	#UI.menu("Tools").add_item("Decrement Shadows West") { longitude=hdt_sun_sub_long(longitude) }
	file_loaded File::basename(__FILE__)
end

